import time
import sys
#
if not Misc.CurrentScriptDirectory() in sys.path:
    sys.path.append(Misc.CurrentScriptDirectory())
#    
ShieldBashTime = 5  # in seconds
lastShieldBashTime = 0  # first bash will be immediate
PetAttackTime = 5  # in seconds
#

import common
#
from System.Collections.Generic import List
from System import Byte, Int32
#
#
def whirlwind_available(weapon):
    if weapon == None:
        return None
    abilities = weapon_abilities()
    if abilities == None:
        return None
    primary = abilities[0]
    secondary = abilities[1]
    if primary == 'Whirlwind Attack':
        #Misc.SendMessage("Returning Whirlwing primary", 5)
        return Player.WeaponPrimarySA
    if secondary == 'Whirlwind Attack':
        return Player.WeaponSecondarySA    
    return None

#
#
import re
def weapon_abilities():
    w_r = Player.GetItemOnLayer('RightHand')
    #Misc.SendMessage("right={}".format(w_r))
    w_l = Player.GetItemOnLayer('LeftHand')
    #Misc.SendMessage("left={}".format(w_l))
    ret = None
    if w_l != None: 
        ret = common.default_weapon_abilities(w_l.ItemID)         
        if ret[0] or ret[1]:
            return ret
    if w_r != None:    
        ret = common.default_weapon_abilities(w_r.ItemID) 
        #Misc.SendMessage("Use right")
    return ret
       

#
def weaponspecials(weapon):
    if weapon == None:
        return None
    abilities = weapon_abilities()
    if not abilities:
        return None
    primary = abilities[0]
    secondary = abilities[1]
    Misc.SendMessage(primary)
    Misc.SendMessage(secondary)
    if primary == None:
        return None
    if secondary == None:
        return None 
    primary_priority = 999   
    if primary in common.weapon_ability_priority:
        primary_priority = common.weapon_ability_priority[primary]
    secondary_priority = 999    
    if secondary in common.weapon_ability_priority:    
        secondary_priority = common.weapon_ability_priority[secondary]
    suggest_primary = 999
    suggest_secondary = 999
    #
    if not primary in common.requires_mount or Player.Mount != None:
        suggest_primary = primary_priority
    if not secondary in common.requires_mount or Player.Mount != None:
        suggest_secondary = secondary_priority
    if suggest_primary == 999 and suggest_secondary == 999:
        return None
    if primary == "Infectious Strike" and Player.GetSkillValue("Poisoning") < 10:
        suggest_primary = 999    
    if secondary == "Infectious Strike" and Player.GetSkillValue("Poisoning") < 10:
        suggest_secondary = 999    
    if suggest_primary < suggest_secondary:
        return Player.WeaponPrimarySA
    else:
        return Player.WeaponSecondarySA
#
def Use_weapon_special(weapon):
    #Misc.SendMessage("Action for 1")
    action = weaponspecials(weapon)
    if action != None and not Player.HasSpecial :
        #Misc.SendMessage("Do Action for 1")
        action()

#                        
    
def IsBoss(enemy):
    if enemy is None:
        return False
    name = enemy.Name
    bosses = ['Master', 'Neira', 'rikktor', 'semidar', 'mephitis' ]
    for boss in bosses:
       if boss.upper() in name.upper():
          return True
    return False      

#
# if there are pets tell them to attack target
#
#
LastPetAttack = 0 
#  
def Attack(enemy):
    global LastPetAttack
    if time.time() > LastPetAttack:        
        LastPetAttack = time.time() + 5
        for pet in common.FindPets():
            Misc.SendMessage("TELL {} TO ATTACK".format(pet.Name))
            Player.ChatSay(5, "{} Attack".format(pet.Name))
            Target.WaitForTarget(1000)
            Target.TargetExecute(enemy)
    Player.Attack(enemy.Serial)    
        
    
Misc.ClearIgnore( )

pets = FindPets()
for pet in pets:
    Misc.IgnoreObject(pet)


consecrate = 0
dont_kill = [ 'a cu sidhe', 'a sheep', 'a dog', 'a cat', 'a horse', 'Dart', 'an energy vortex' ]
ignore_type = [0x007b ]
#0x0190, 0x0191, 
last_attack_msg = time.time()
last_attack_serial = 0
#
last_enemy = None
while True:
    #
    enemy_filter = Mobiles.Filter()
    enemy_filter.Enabled = True
    enemy_filter.RangeMin = -1
    if Misc.CheckSharedValue("MaxRange"):
        enemy_filter.RangeMax = Misc.ReadSharedValue("MaxRange")
    else:    
        enemy_filter.RangeMax = 8
    enemy_filter.Notorieties = List[Byte](bytes([3,4,5,6]))

    on_me_filter = Mobiles.Filter()
    on_me_filter.Enabled = True
    on_me_filter.RangeMin = -1
    on_me_filter.RangeMax = 11
    on_me_filter.Notorieties = List[Byte](bytes([3,4,5,6]))
    enemies = Mobiles.ApplyFilter(enemy_filter)
    up_close_enemies = Mobiles.ApplyFilter(on_me_filter)
    #Misc.SendMessage("{} enemies up close".format(len(up_close_enemies)))
    
    w_r = Player.GetItemOnLayer('RightHand')
    #Misc.SendMessage("right={}".format(w_r))
    w_l = Player.GetItemOnLayer('LeftHand')
    #Misc.SendMessage("left={}".format(w_l))
    if w_l != None: 
        weapon = w_l
        Misc.Pause(500)
    elif w_r != None:    
        weapon = w_r
        Misc.Pause(500)
    else:
        weapon = None  
    
    if len(enemies) > 0:
        #Misc.SendMessage("{} enemies within 5 squares".format(len(enemies)))
        Player.SetWarMode(True)
        if len(up_close_enemies) > 0 and Player.WarMode:
            enemy = Mobiles.Select(up_close_enemies, 'Nearest')
        else:    
            enemy = Mobiles.Select(enemies, 'Nearest')
        if enemy.Name in dont_kill  or enemy.Body in ignore_type or "wandering healer" in enemy.Name:
            Misc.IgnoreObject(enemy.Serial)
            enemy = None
        # ignore energy vortex
        if enemy and enemy.Body == 0x00A4 and enemy.Hue == 0:    
            Misc.IgnoreObject(enemy.Serial)
            enemy = None
        #if enemy == last_enemy or Player.InRangeMobile(enemy, 3):
            #pass
        #else:
            #Player.PathFindTo(enemy.Position.X, enemy.Position.Y, enemy.Position.Z)
            #last_enemy = enemy   
        if enemy != None:
            if last_attack_serial != enemy.Serial or time.time() > last_attack_msg + 5:
                Mobiles.Message(enemy, 5, "Attacking 0x{:08x}".format(enemy.Serial))
                last_attack_msg = time.time()
                last_attack_serial = enemy.Serial
                if (Player.DistanceTo() > 3) and (enemy.Hits == enemy.HitsMax):
                    Player.InvokeVirtue("Honor")
                    Target.WaitForTarget(1000)
                    Target.TargetExecute(enemy)
            #
            if time.time() < consecrate-.5:
                Spells.CastMastery("Shield Bash")
            Player.Attack(enemy.Serial)
            #Target.AttackTargetFromList("attack")
            #Misc.SendMessage("Notoriety is {}".format(enemy.Notoriety)) 
        if Player.Mana > 20:
            if Player.Stam < (.85 * Player.StamMax):
                Journal.Clear()
                Spells.CastChivalry("Divine Fury")
                Misc.Pause(500)
            if time.time() > consecrate:
                #Misc.SendMessage("Casting consecrate")
                Spells.CastChivalry('Consecrate Weapon')
                consecrate = time.time()+8

            if not Player.HasSpecial:
                w_r = Player.GetItemOnLayer('RightHand')
                #Misc.SendMessage("right={}".format(w_r))
                w_l = Player.GetItemOnLayer('LeftHand')
                #Misc.SendMessage("left={}".format(w_l))
                if w_l != None: 
                    weapon = w_l
                    Misc.Pause(750)
                elif w_r != None:    
                    weapon = w_r
                    Misc.Pause(750)
                else:
                    weapon = None
                #
                range = Items.GetPropValue(weapon, 'Range') 
                if range < 2:
                    range = 2         
                on_me_filter.RangeMax = range          
                up_close_enemies = Mobiles.ApplyFilter(on_me_filter)
                #
                num_up_close_enemies = len(up_close_enemies) 
                if IsBoss(enemy):
                    num_up_close_enemies = 1
                if  num_up_close_enemies > 1:
                    action = whirlwind_available(weapon)
                    if action != None:
                        Misc.SendMessage("Whirlwind", 5)
                        action()
                    else:
                        Use_weapon_special(weapon)
                elif not Player.HasSpecial and Player.Mana > 30:                    
                    Use_weapon_special(weapon)
#                      
    if Player.Weight > (.8 * Player.MaxWeight) or len(Player.Backpack.Contains) > 80 :
        Player.HeadMessage(1, "Heavy") 
        Misc.Pause(750)
